/*
 * Makarov Alex
 * alexd.makarov@gmail.com
 * DSI
 */

package bitel.billing.server.contract.action.web;

import bitel.billing.server.contract.bean.ContractManager;
import bitel.billing.server.contract.bean.Contract;
import bitel.billing.server.util.Utils;
import bitel.billing.server.ActionBase;

import javax.servlet.http.HttpServletResponse;

import java.io.IOException;

import java.sql.PreparedStatement;
import java.sql.SQLException;

import ru.dsi.bgbilling.robokassa.util.md5;
import ru.dsi.bgbilling.robokassa.util.Mailme;
import ru.dsi.bgbilling.robokassa.util.Util;

/**
 *
 * @author makarovad
 */
public class ActionRequestRobokassa extends ActionBase {
    @Override
    public void doAction(){
        try{
            // 1. Добавляем в таблицу payment_robokassa строку и генерируем идентификатор платежа.
            // Далее этот идентификатор будем передавать в робокассу.
            String insSQL = "insert into payment_robokassa(cid,dt) values(?,?)";
            int invid = -1;
            java.util.Date d= new java.util.Date();
            java.sql.Date parD = new java.sql.Date(d.getTime());            
            try{
                PreparedStatement lps = con.prepareStatement(insSQL,1);
                lps.setInt(1, cid);
                lps.setDate(2, parD);
                lps.executeUpdate();
                invid = Utils.lastInsertId(lps);
            }catch(SQLException e){
                e.printStackTrace();
                //Если в результате работы произошла ошибка - отправляем на почту сообщение
                Mailme m = new Mailme();
                try{
                    m.sendMail("Ошибка при генерации INVID CID = "+cid, e.getMessage());
                }catch(Exception e1){
                    e1.printStackTrace();
                }
            }
            // 1. формируем запрос на робокассу
            ContractManager cm = new ContractManager(con);
            Contract contr = cm.getContractByID(this.cid);
            String title = contr.getTitle();

            //String invid = "0";
            if(invid == -1) invid = 0;
            String s_login = md5.getMrthLogin();
            String s_md5 = md5.md5c("", Integer.toString(invid), Integer.toString(this.cid));
            // ниже написано Пополнение баланса договора + номер договора
            String e_title = Util.encode("Пополнение баланса договора "+title);
            //String desc = "%CF%EE%EF%EE%EB%ED%E5%ED%E8%E5%20%E1%E0%EB%E0%ED%F1%E0%20%E4%EE%E3%EE%E2%EE%F0%E0%20 "+e_title;
            String url_robo = "https://merchant.roboxchange.com/Index.aspx?MrchLogin="+s_login+
                              "&OutSum="+"&InvId="+invid+"&Desc="+e_title+"&shp_contract="+this.cid+
                              "&IncCurrLabel=PCR&SignatureValue="+s_md5;
            System.out.println(url_robo);
            HttpServletResponse resp = response;
            resp.sendRedirect(url_robo);             
        }catch(IOException e){
            e.printStackTrace();
        }
    }
}
